
#include <stdio.h>
#include <conio.h>
#include "allegro.h"

void DrawGraphic(int x,int y,int c);

unsigned char Data[42000];              /* Buffer for BugaBoo TAP File */

int main(int argc,char *argv[])
{
        FILE *f;
        RGB  Palette[256];
        BITMAP *Dragon;
        int  i,c,n,x,y,x1;
        allegro_init();                 /* Boot allegro 320,200,8 mode */
        set_color_depth(8);
        set_gfx_mode(GFX_AUTODETECT,320,200,320,200);
        f = fopen("BUGA.TAP","rb");     /* Read in the TAP file */
        fread(Data,sizeof(Data),1,f);
        fclose(f);

        #ifdef DEMO                     /* Demo just shows some of the map */
        for (x = 0;x < 40;x++)
                for (y = 0;y < 25;y++)
                        DrawGraphic(x*8+8,y*8+8,Data[0x1FE3+x+y*96]);
        getch();
        return 0;
        #endif

        rectfill(screen,0,0,320,200,1); /* Fill screen with blue */
        for (x = 0;x < 256;x++)         /* Draw the 256 possible bitmaps */
                DrawGraphic((x % 32)*8+8,(x/32)*8+8,x);
        blit(load_bitmap("logo.bmp",    /* Copy BugaBoo bitmap */
                                Palette),screen,0,0,8,104,202,61);
        for (x = 8;x < 8+202;x++)       /* Check background */
                for (y = 104;y < 104+61;y++)
                        if (getpixel(screen,x,y) != 14)
                                putpixel(screen,x,y,0);


        c = -1;
        for (n = 0;n < 0x100;n++)       /* Extract 16x16 flea graphics */
        {
                if (n/32 == 0 || n/32 == 2 ||
                    n/32 == 3 || n/32 == 5 || n/32 == 7)
                {
                        if (n % 32 == 0) c++;
                        x = 280;
                        y = c*16+8;
                        y = y + (n % 8);
                        if (n % 32 >= 8 && n % 32 < 16) x += 8;
                        if (n % 32 >= 16) y += 8;
                        if (n % 32 >= 16 && n % 32 < 24) x += 8;
                        for (x1 = 0;x1 < 8;x1++)
                            putpixel(screen,x+x1,y,
                                     (Data[0x1EE3+n] & (0x80>>x1)) ? 6:0);
               }
        }
        for (y = 8;y < 16+8+c*16;y++)
            for (x = 280;x < 296;x++)
                putpixel(screen,296+15-(x-280),y,getpixel(screen,x,y));

        Dragon = load_bitmap("dragon.bmp",Palette);
        blit(Dragon,screen,0,0,216,102,48,32);
        for (x = 0;x < 48;x++)
                for (y = 0;y < 32;y++)
                {
                        n = getpixel(screen,216+x,y+102);
                        if (n == 0x24)
                        {
                                n = 0;
                                putpixel(screen,x+216,y+102,6);
                        }

                        putpixel(screen,216+x,y+134,n);
                        putpixel(screen,311-x,y+134,n);
                        putpixel(screen,311-x,y+102,getpixel(screen,x+216,y+102));
                }

        f = fopen("bugaboo.dat","wb");  /* Write the layout file */
        fputc(96,f);                    /* Write width */
        fputc(85,f);                    /* Write height */
        for (i = 0;i < 85*96;i++)       /* Write data */
            fputc(Data[i+0x1FE3],f);
        fclose(f);

        f = fopen("spectrum.rom","rb"); /* Read in the Spectrum ROM */
        fread(Data,16384,1,f);
        fclose(f);

        for (n = 0x3D00;n < 0x4000;n++) /* Copy the characters out */
        {
                c = (n - 0x3D00)/8;
                x = (c % 32) * 8+8;
                y = (c / 32)*8 + 72 + n % 8;
                for (x1 = 0;x1 < 8;x1++)
                        putpixel(screen,x+x1,y,
                                (Data[n] & (0x80 >> x1)) ? 15 : 0);
        }
        textout_centre(screen,font,"Ripped by Paul Robson December 2001",160,190,14);
        if (argc == 2) getch();
        save_bitmap("bugaboo.pcx",screen,Palette);
        return 0;
}

static int ColMap[8] = { 15,9,12,13,10,11,14,0 };

void DrawGraphic(int x,int y,int c)
{

	int x1,y1,n;
        n = ColMap[c & 7];              /* Convert to draw colour */
        if (n == 0 && (c >> 3) != 0) n = 15;
        if (c & 8)                      /* Set 1 */
                c = 0x1DE3+(c >> 4)*8;
        else
                c = 0x1E63+(c >> 4)*8;  /* Set 2 */
        for (x1 = 0;x1 < 8;x1++)
                for (y1 = 0;y1 < 8;y1++)
                        if (Data[c+y1] & (0x80 >> x1))
                                putpixel(screen,x+x1,y+y1,n);
                        else
                                putpixel(screen,x+x1,y+y1,0);

}

